// lac.c
// 4spcs/tab

/*** DEBUG `ƃfobObZ[WiHjo ***/

#include "lac.h"


// 
// *ret ͏i0߁jĂ邱
static void ProcessingArgs (int argc, char **argv, struct args *ret)
// ret: ߂li[pi̎wi[j
{
int i;

	if (argc <= 1) Error (Usage);
	for (i=1; i<argc; i++) {
		if (strcmpi (argv[i], "-?") == 0) Error (Usage);
		if (strcmpi (argv[i], "-v") == 0 && ret->sw_v == 0) {
			ret->sw_v = i;
			continue;
		}
		if (strcmpi (argv[i], "-l") == 0 && ret->sw_l == 0) {
			ret->sw_l = i;
			continue;
		}
		if (strnicmp (argv[i], "-c", 2) == 0 && ret->sw_c == 0) {
			ret->sw_c = i;
			if (strlen (argv[i]) > 2)
				ret->cnf_file = &(argv[i][2]);
			else {
				i++;
				if (i >= argc) Error (Sw_c);
				ret->cnf_file = argv[i];
			}
			continue;
		}
		// \[Xt@C̎w
		if (strnicmp (argv[i], "-s", 2) == 0 && ret->src_file == 0) {
			ret->sw_s = i;
			if (strlen (argv[i]) > 2)
				ret->src_file = &(argv[i][2]);
			else {
				i++;
				if (i >= argc) Error (Src_file);
				ret->src_file = argv[i];
			}
			continue;
		}
	}
}


// RtBOɋLqꂽRpCIvṼZbg
static void SetCCOptions_Cnf (const char *buf, struct config *ret, int *ml)
// buf: sobt@igqEXy[XERpCi{IvVj̍\j
// ret: ߂li[piret->cc ̃Xg̖ɗvfǉj
// ml: sw̃tO
{
char *delim = " \t";
char *tmp;
size_t len;
struct cc_opt *ptr = ret->cc;
struct cc_opt *new;
int mltmp = *ml;

	// gq̒o
	len = strcspn (buf, delim);
//	if ((tmp = malloc (len + 1)) == NULL) Error (NoMem);
//	strncpy (tmp, buf, len)[len] = '\0';	// strncpy  n Rs[ '\0' tȂ
	if ((tmp = strndup (buf, len)) == NULL) Error (NoMem);

	if (mltmp) {
		if (!ptr) Error (SetCCOpt_Ml_RetCC);
		// sw̓rȂ烊Xg̖ֈړ
		while (ptr->next) ptr = ptr->next;
	}
	else
		// gqłłɓo^Ă邩
		if (CcoptSearchext (ptr, tmp)) Error (CnfFormatError);

	// Xg̗vf쐬
	new = CcoptNew (tmp, buf + len + strspn (buf + len, delim), 0, ml);
	if (new == NULL) {
		// malloc Ă݂ăsfc
		// ЂǂIiȂ璼j
		if (malloc (strlen (buf + len + strspn (buf + len, delim)) + 1) == NULL)
			Error (NoMem);
		else Error (CnfFormatError);
	}

	// Xgɒǉ
	if (mltmp) {
		if (CcoptCatnc (ptr, new) == NULL) Error (NoMem);
		CcoptFree (new);
	}
	else if (ptr) {
		if (CcoptCat (ptr, new) == NULL) Error (NoMem);
		CcoptFree (new);
	}
	else ret->cc = new;

	free (tmp);
}


// RtBOɋLqꂽCũZbg
static void SetLibs_Cnf (const char *buf, struct cnfdef **ptr)
// buf: sobt@
// ptr: CũXgւ̃|C^i߂li[pj
{
char *delim = " \t";
void *tmp;
size_t len;
struct cnfdef *ptr2;
struct cnfdef *new;

	// wb_t@C̒o
	len = strcspn (buf, delim);
//	tmp = malloc (len + 1);
//	if (tmp == NULL) Error (NoMem);
//	strncpy (tmp, buf, len);
//	((char *)tmp)[len] = '\0';	// strncpy  n Rs[ '\0' tȂ
	if ((tmp = strndup (buf, len)) == NULL) Error (NoMem);
#ifdef DEBUG
printf ("tmp : %s\n", tmp);
#endif

	ptr2 = *ptr;
	// 󕶎iftHgjłȂꍇ
	if (((char *)tmp)[0]){
		// wb_t@Cłłɓo^Ă邩
		if (CnfdefSearchh (ptr2 ,tmp)) Error (CnfFormatError);

		// Xgvf쐬
		if ((new = CnfdefNew (tmp, 0, 0)) == NULL) Error (NoMem);
		new->libs = LibsNew (buf+len+strspn (buf+len, delim));
		if (new->libs == NULL) Error (NoMem);

		// Xgɒǉ
		if (*ptr) {
			if (CnfdefCat (*ptr, new) == NULL) Error (NoMem);
			CnfdefFree (new);
		}
		else *ptr = new;
	}
	// 󕶎iftHgj̏ꍇ
	else {
		// łɃXgɂ邩H
		ptr2 = CnfdefSearchh (ptr2, tmp);

		// łɂvfɒǉ
		if (ptr2) {
		struct libs *new;
			if ((new = LibsNew (buf+len+strspn (buf+len,delim))) == NULL) Error (NoMem);
			if (LibsCat (ptr2->libs, new) == NULL) Error (NoMem);
			LibsFree (new);
		}
		// Vvf쐬AXgɒǉ
		else {
			if ((new = CnfdefNew (tmp, 0, 0)) == NULL) Error (NoMem);
			new->libs = LibsNew (buf+len+strspn (buf+len, delim));
			if (new->libs == NULL) Error (NoMem);
			// Xgɒǉ
			if (*ptr) {
				if (CnfdefCat (*ptr, new) == NULL) Error (NoMem);
				CnfdefFree (new);
			}
			else *ptr = new;
		}
	}

	// e|̃obt@
	free (tmp);
}


// RtBÕRg̍폜
static void DelCmt_Cnf (char *str)
{
const char *delim = " \t";

	while (*str && *str != '#') {
		str += strcspn (str, delim);
		str += strspn (str, delim);
	}
	*str = '\0';
}


// RtBO̓ǂݍ݁ij
static void ReadingConfig (const char *pathfile, struct config *ret)
// pathfile: tpXtȂt@C
// ret: ߂li[p
{
Vstring *tmp;		// ǂݍ݃obt@
FILE *fp;
struct cnfdef **md;	// ftHgESX [h؂芷c̖c
int ml = 0;			// gq`̕sw̃tO

	// t@CJ
#ifdef DEBUG
printf ("config.file : %s\n", pathfile);	//debug
#endif
	if ((fp = fopen (pathfile, "r")) == NULL) Error (CnfNotFound);

	// ǂݍ
	md = &(ret->def);
	tmp = VstringNew();
	while (feof (fp) == 0) {
		// sǂݍ
		if (VstringFgets (tmp, fp) == NULL) Error (FileAcsFault);
		// s '\n' ΍폜
		if (*(tmp->mem) && (tmp->p)[-1] == '\n') {
			(tmp->p)[-1] = '\0';
			tmp->length--;
		}
		// Rg폜
		DelCmt_Cnf (tmp->mem);
		// s͖
		if (ml == 0 && *(tmp->mem) == '\0') continue;
#ifdef DEBUG
puts (tmp->mem);
#endif
		// 1g[N؂oĂꍇ[́B
		if ((tmp->mem)[0] == '.') {	// . ̏ꍇ
			SetCCOptions_Cnf (tmp->mem, ret, &ml);
#ifdef DEBUG
{
struct cc_opt *temp=ret->cc;
    while (temp && temp->next) temp = temp->next;
    while (temp && temp->nc) temp = temp->nc;
    if (temp) printf ("ext: %s(%d) = %s\n", temp->ext, ml, temp->cc);
}
#endif
			continue;
		}
		else if ((tmp->mem)[0] == '=') {	// = ̏ꍇ
		char drive[2+1], path[PATH_MAX + 1], ext[18+1+3+1];
		char temp1[PATH_MAX + 1], *temp2, *delim = " \t";
			if (ml) Error (CnfFormatError);
			// pX𒊏o
			_splitpath (pathfile, drive, path, ext, ext);
			// pX{t@C쐬
			temp2 = &tmp->mem[1] + strspn (&tmp->mem[1], delim);
			temp2[strcspn (temp2, delim)] = '\0';
			snprintf (temp1, sizeof (temp1), "%s%s%s", drive, path, temp2);
			ReadingConfig (temp1, ret);
			continue;
		}
		else {
			if (ml) Error (CnfFormatError);
#ifdef DEBUG
printf ("tmp->mem : %s\n", tmp->mem);
#endif
			SetLibs_Cnf (tmp->mem, md);	// ȊOCu̓o^
#ifdef DEBUG
{
struct cnfdef *temp=*md;
    while (temp && temp->next) temp=temp->next;
    printf ("h-l: %s =", temp->h);
    {
    struct libs *temp2=temp->libs;
	while (temp2) {
	    printf (" %s", temp2->lib);
	    temp2=temp2->next;
	}
    putchar ('\n');
    }
}
#endif
		}
	}

	// `FbN
	if (ret->cc == 0) Error (NoExtInCnf);

	// I
	VstringFree (tmp);
	fclose (fp);
#ifdef DEBUG
fflush (stdout);
#endif
}


// RtBO̓ǂݍ
// *ret ͏i0߁jĂ邱
static void ReadConfig (struct args *args, struct config *ret)
// args: ̏
// ret: ߂li[p
{
	// t@C
	if (args->sw_c) ReadingConfig (args->cnf_file, ret);
	else {
	char def_cnf[PATH_MAX + 1];	// ftHg̃RtBOt@C
		snprintf (def_cnf, sizeof (def_cnf), "%s/lac.cnf", args->execdir);
		ReadingConfig (def_cnf, ret);
	}
}


// \[Xt@CT
static void SearchSrcInArgs
 (int argc, char **argv, struct args *args, const struct config *config)
// args: ̏ԁE߂li[p˂Ă
// config: RtBȌ
{
int i;
char ext[18+1+3+1];	// gqi[p
char *astmp;

	ext[0] = '.';	// ׍Hif[^\j

	// RtBOœo^ꂽgqt@CT
	for (i=1; i<argc; i++) {
		if (i == args->sw_c) {
			if (strlen (argv[i]) <= 2) i++;
			continue;
		}
		if (i == args->sw_l || i == args->sw_v || (args->sw_s && i != args->sw_s))
			continue;
		// gqƍ
		if (args->sw_s) {
			if (strlen (argv[i]) != 2) {
				i++;
				astmp = argv[i];
			}
			else astmp = &argv[i][2];
		}
		else astmp = argv[i];
		stcgfe (&ext[1], astmp);
		if ((args->cc = CcoptSearchext (config->cc, ext)) != 0) {
			args->src_file = astmp;	// \[Xt@CƂēo^
			return;
		}
		if (args->sw_s) break;
	}

	// \[Xt@C炵Ȃ
	Error (Src_file);
}


// Xy[XŖ߂ij
inline static void FillSpc (char *head, char *tail)
// head,tail ̈
{
	while (head <= tail) *head++ = ' ';
}


// Rg폜
// ł /* RgɓĂ */ T
static int DelCmt (char *buf, int now)
// buf: sobt@
// now: tOiłɃRgɓĂ邩Hj
// ߂l: ŐṼtOiłɃRgɓĂ邩Hj
{
char *tmp;

	// łɃRg
	while (now) {
		if (tmp = strchr (buf, '*')) {
			// '*' Ƃ肠폜
			FillSpc (buf, tmp++);
			if (*(buf = tmp) == '/') {
				// "*\"  \ 폜
				*buf = ' ';
				now = 0;
			}
		}
		else break;
	}

	return now;
}


// 폜
static void DelStr (char *buf, char chr)
// buf: 
// chr: ̕i"  ' w肷邱Ɓj
{
char *p, *tmp;
	// 擪 chr 疄߂
	if (*buf == chr) *buf++ = ' ';

	//  chr 
	do {
		// s܂ chr Ȃ當@G[
		if ((p = strchr (buf, chr)) == NULL) Error (SrcSyntax);

		// \chr ǂ`FbN
		if (p[-1] == '\\') {
			tmp = p;
			// Oɖ߂ \\chr łȂ`FbN
			while (tmp >= buf && *--tmp == '\\');
			// \chr Ȃ폜ďp
			if (((p - tmp) & 1) == 0) {
				FillSpc (buf, p);
				buf = p;
			}
			else break;
		}
		else break;
	} while (1);

	// 폜
	FillSpc (buf, p);
}


// Rgƕ폜
// #include "`" ̕폜Ă܂
static int DelCmtAndStr (char *buf, int now)
// buf: 
// now: tOiłɃRgj
// ߂l: tOiRgj
{
const char *delim = " \t";

	while (*buf) {
		if (now)
			if (now = DelCmt (buf, now))
				break;
		buf += strspn (buf, delim);
		if (strncmp (buf, "/*", 2) == 0) {
			buf[0] = buf[1] = ' ';
			buf += 2;
			now = 1;
			continue;
		}
		else if (strncmp (buf, "//", 2) == 0) {
			*buf = '\0';
			break;
		}
		else if (*buf == '\"' || *buf == '\'') DelStr (buf, *buf);
		else buf++;
	}
	return now;
}


// \[XɋLqĂwb_t@C烉Cu
static struct libs *SetLibs_Src
 (struct libs *now, const char *h, size_t len, const struct cnfdef *cnfdef)
// now: N郉CũXg
// h: \[Ẍꕔig[Nj
// len: h̒
// cnfdef: .hCu`Xg
// ߂l: Vnow
{
char *hn;
struct cnfdef *tmp;

//	hn = malloc (len + 1);
//	if (hn == NULL) Error (NoMem);
//	strncpy (hn, h, len);
//	hn[len] = '\0';	// strncpy  n Rs[ '\0' tȂ
	if ((hn = strndup (h, len)) == NULL) Error (NoMem);
#ifdef DEBUG
printf ("%s :", hn);	// debug
#endif
	// Xgwb_t@C
	if (tmp = CnfdefSearchh (cnfdef, hn)) {
		// t@C烉CuXgɒǉ
		if ((now = LibsCat (now, tmp->libs)) == NULL) Error (NoMem);
#ifdef DEBUG
{
const struct libs *libs = tmp->libs;
	while (libs) {
		printf (" %s", libs->lib);
		libs = libs->next;
	}
}
#endif
	}

#ifdef DEBUG
putchar ('\n'); fflush (stdout);
#endif
	free (hn);
	return now;
}


// \[Xt@C
static struct libs *Search (struct config *config, struct libs *libs, const char *fname)
// config: RtBO
// libs: łɂ郉CũXg
// fname: \[Xt@C
// ߂l: NׂCũXgidt@Cj
{
struct libs *ret = libs;	// ߂l
FILE *fp;
Vstring *buf;				// ǂݍ݃obt@
char *delim = " \t";
int incmt = 0;
void *tmp, *tmp2;

	// t@CJ
	fp = fopen (fname, "r");
	if (fp == NULL) Error (SrcNotFound);

	buf = VstringNew();
	// ǂݍ݂Ȃ猟
	while (feof (fp) == 0) {
		VstringClear (buf);
		if (VstringFgets (buf, fp) == NULL) Error (FileAcsFault);
#ifdef DEBUG
printf ("%s", buf->mem);
#endif
		// Rg̍폜
		if (incmt = DelCmtAndStr (buf->mem, incmt)) continue;
		// # include <...> ̌
		tmp = buf->mem + strspn (buf->mem, delim);
		if (*(char *)tmp++ == '#') {
			tmp += strspn (tmp, delim);
			if (strncmp (tmp, "include", 7) == 0) {
				tmp += 7 + strspn (tmp+7, delim);
				if (((char *)tmp)[0] == '<') {
					tmp2 = strchr (tmp+1, '>');
					if (tmp2 == tmp+1) Error (SrcSyntax);
					// Cǔ
					ret = SetLibs_Src
						(ret, tmp+1, tmp2-(tmp+1), config->def);
				}
			}
		}
	}

#ifdef DEBUG
fflush (stdout);
#endif
	VstringFree (buf);
	return ret;
}


// NׂCu\
static void View (const struct libs *libs)
// libs: CũXg
{
	while (libs){
		printf ("%s\n", libs->lib);
		libs = libs->next;
	}
}


// Xg argv z쐬
static char **MakeCargvFromList_CallCC (const struct libs *list)
// list: Xg
// ߂l: argvz
{
const struct libs *ltmp = list;
char **ret = NULL, **ctmp;
int i;

	if (list == 0) return ret;

	// Xg̗vf𐔂
	for (i=0; ltmp->next; i++) ltmp = ltmp->next;

	// Xg argv z
	if ((ret = malloc ((i + 1) * sizeof (char **))) == NULL) Error (NoMem);

	ctmp = ret;
	do {
		if ((*ctmp++ = strdup (list->lib)) == NULL) Error (NoMem);
	} while (list = list->next);
	*ctmp = NULL;	// I[L

	return ret;
}


// ׂ胂[hER}hC\
static void Verbose_CC (const char **Cargv)
// Cargv: R}hC
{
	if (Cargv && *Cargv) {
		putstring (*Cargv++);
		while (*Cargv) {
			putchar (' ');
			putstring (*Cargv++);
		}
		putchar ('\n');
	}
}


// argv zi 0j
// ׂ malloc ȂǂŊmۂĂ̂ƂĂ
static void argvFree (char **argv)
{
	while (*argv) free (*argv++);
	free (argv);
}


// ǂݍ񂾃RtBOƃ\[Xt@Cɏ
static int Process (int argc, char **argv, struct args *args, struct config *config)
{
struct libs *libs = NULL;		// CuXgi[p
struct cc_opt *cc = args->cc;	// R}hicc_opt.ncjXg
int exitcode = 0;				// IR[h
char pathnode[PATH_MAX + 1];	// \[Xt@C̃pX{m[h̊i[p

#ifdef DEBUG
if (cc) printf ("cc->ext: %s\n", cc->ext);
else {
	puts ("cc is NULL!");
	return -32768;
}
#endif

	// pX{m[h𒊏o
	stcgfn (pathnode, args->src_file);
#ifdef DEBUG
printf ("pathnode: %s\n", pathnode);
#endif

	// ftHg̃CuXgɓo^
	libs = SetLibs_Src (libs, "", 0, config->def);

	// cc->nc NǂȂ珈
	while (cc && !exitcode) {
	char sfname[PATH_MAX + 1];	// \[Xt@Ci[p
	struct libs *list;		// R}ḧXg
	char **Cargv;			// R}h
		// \[Xt@C̐
		snprintf (sfname, sizeof (sfname), "%s%s", pathnode, cc->ext);
		// \[X𒲂ׂ邩H
		if (cc->flag.search) {
			libs = Search (config, libs, sfname);	// \[XT[`
			LibsShrink (libs);			// ̃Cu܂Ƃ߂
			// -l w肳ĂΕ\Ɛe֋A
			if (args->sw_l) {
				View (libs);
				exitcode = 0;
				break;
			}
		}

		// RpC{IvVXgɂ
		if ((list = LibsNew (cc->cc)) == NULL) Error (NoMem);

		// \[Xt@CXgɒǉ
		if ((list = LibsAddstring (list, sfname)) == NULL) Error (NoMem);

		// R}hCA̃IvV cc_options ǉ
		// \[Xt@C args ̂g
		if (cc->flag.useopt) {
		int i;
			for (i=1; i<argc; i++) {
				if (i == args->sw_l || i == args->sw_v
				    || argv[i] == args->src_file) continue;
				if (i == args->sw_c || i == args->sw_s) {
					if (strlen (argv[i]) <= 2) i++;
					continue;
				}
				if ((list = LibsAddstring (list, argv[i])) == NULL) Error (NoMem);
			}
		}

		// libs ̃Cuǉ
		if (cc->flag.uselib)
			if ((list = LibsCat (list, libs)) == NULL) Error (NoMem);

		// -l w肳ĂāAcc->nc  0 Ȃ\Őe֋A
		if (args->sw_l && !cc->nc) {
			View (libs);
			exitcode = 0;
			break;
		}

		// Xg argv z쐬
		Cargv = MakeCargvFromList_CallCC (list);

		// Xg
		LibsFree (list);

		// ׂ胂[hH
		if (args->sw_v) Verbose_CC ((const char **)Cargv);

		// qvZXN
		if ((exitcode = spawnvp (P_WAIT, Cargv[0], Cargv)) == -1) Error (MisCallCC);

		// qvZX 0 ȊȌIR[hԂ烁bZ[W\Ē~
		if (exitcode) eprintf ("%sIR[h%dԂ܂\n", Cargv[0], exitcode);

		// Cargv 
		argvFree (Cargv);

		// ɐi
		cc = cc->nc;
	}

	return exitcode;
}


// C[`
int main (int argc, char **argv)
{
struct args args;		// p
struct config config;	// RtBOt@Cp

	// \̂̏
	bzero (&args, sizeof (args));
	bzero (&config, sizeof (config));
	// vO̊i[
	args.progname = _basename (argv[0]);
	// NfBNg̎擾
	strncpy (args.execdir, _procp->exe_path, sizeof (args.execdir));

#ifdef DEBUG
puts ("*");	// debug
#endif
	// 
	ProcessingArgs (argc, argv, &args);
#ifdef DEBUG
puts ("*");	// debug
#endif
	// RtBOǂݍ
	ReadConfig (&args, &config);
#ifdef DEBUG
puts ("*");	// debug
#endif
	// R}hC\[Xt@CT
	SearchSrcInArgs (argc, argv, &args, &config);
#ifdef DEBUG
puts ("*");	// debug
#endif
	//  exit
	exit (Process (argc, argv, &args, &config));
}

// End of file.